require 'net/http'
require 'uri'
require 'base64'
require 'openssl'
require 'yaml'
require 'json'
require 'digest'
require 'time'
require 'tempfile'
require 'stringio'
require 'ruby-progressbar'

module Qiniu2Upyun
  require_relative 'qiniu2upyun/version'
  require_relative 'qiniu2upyun/qiniu'
  require_relative 'qiniu2upyun/upyun'
  require_relative 'qiniu2upyun/migrating'
  require_relative 'qiniu2upyun/config'
  require_relative 'qiniu2upyun/error'
  require_relative 'qiniu2upyun/data'
  require_relative 'qiniu2upyun/record'
  require_relative 'qiniu2upyun/utils'

  def self.migrate!(options={})
    Config.load!(options.delete(:config))

    qiniu = Qiniu.new(Config.qiniu)
    upyun = Upyun.new(Config.upyun)

    Migrating.new(qiniu, upyun).perform!
  end
end
