require 'optparse'

module Qiniu2Upyun
  class CLI
    DEFAULT_OPTIONS = {
      config: "#{ENV['HOME']}/.qiniu2upyun.yml"
    }

    def parse
      options = {}

      parser = OptionParser.new do |opts|
        opts.banner = "Usage: qiniu2upyun [options]"

        opts.on("-C", "--config PATH", 
                "Load PATH as a config file",
                "(default: #{DEFAULT_OPTIONS[:config]})") do |c|

          options[:config] = c
        end

        opts.on("-V", "--version", "Show version") do |v|
          require File.expand_path('../version', __FILE__)

          puts "qiniu2upyun version #{Qiniu2Upyun::VERSION}"

          exit
        end

        opts.on("-h", "--help", "Show help") do |h|
          puts opts

          exit
        end
      end.parse!

      options
    end

    def run!
      options = DEFAULT_OPTIONS.merge(parse)

      require File.expand_path('../../qiniu2upyun', __FILE__)

      Qiniu2Upyun.migrate!(options)
    end
  end
end
