module Qiniu2Upyun
  class Config
    class Qiniu
      attr_reader :access_key, :secret_key, :bucket, :domain

      def initialize(options)
        @access_key = options['access_key']
        @secret_key = options['secret_key']
        @bucket     = options['bucket']
        @domain     = options['domain'] || default_domain
      end

      def default_domain
        "http://#{bucket}.qiniudn.com"
      end
    end

    class Upyun
      attr_reader :username, :password, :bucket

      def initialize(options)
        @username = options['username']
        @password = options['password']
        @bucket   = options['bucket']
      end
    end

    class << self
      attr_reader :qiniu, :upyun

      def load!(path)
        raise NoConfigFileFoundError.new(path) unless File.exists?(path)

        config = YAML.load_file(path)

        @qiniu = Qiniu.new(config['qiniu'])
        @upyun = Upyun.new(config['upyun'])
      end
    end
  end
end
