module Qiniu2Upyun
  class Data
    attr_reader :io, :bar

    def initialize(io, bar)
      @io  = io
      @bar = bar
    end

    def read(*args, &block)
      result = io.read(*args, &block)

      length = args.last.length

      length > 0 ?  bar.progress += length : bar.finish

      result
    end

    def write(*args, &block)
      result = io.write(*args, &block)

      bar.progress += result

      bar.finish if bar.total == io.length

      result
    end

    def method_missing(method, *args, &block)
      io.send(method)
    end
  end
end
