module Qiniu2Upyun
  class NoConfigFileFoundError < StandardError
    def initialize(path)
      @path = path
    end

    def message
      "No config file found: #{@path}"
    end
  end

  class ResponseError < StandardError
    def initialize(response)
      @response = response
    end

    def message
      "<#{@response.code}: #{@response.body}>"
    end
  end

  class NoActionError < StandardError
  end
end
