module Qiniu2Upyun
  class Record
    PATH = '/tmp/qiniu2upyun'
    START_MARKER = '0'

    def get
      File.exists?(PATH) ? File.open(PATH, 'r').read.split(':') : [START_MARKER, nil]
    end

    def set(marker, key)
      yield if block_given?

      File.open(PATH, 'w').write("#{marker}:#{key}")
    end

    def delete
      File.delete(PATH) if File.exists?(PATH)
    end

    def recording(&block)
      marker, key = get

      if key
        puts "Migration is not completed on time.(marker: #{marker}, key: #{key})"
        puts "    1: Continue"
        puts "    2: Restart"
        print "Input: "

        case gets.chomp.to_i
        when 1
        when 2 then marker, key = START_MARKER, nil
        else 
          raise NoActionError
        end
      end

      yield(marker, key)

      delete
    end
  end
end
